/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   lm_parser.c                                        :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: mndhlovu <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/03/25 06:30:51 by mndhlovu          #+#    #+#             */
/*   Updated: 2019/03/25 06:30:57 by mndhlovu         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "lem_in.h"

static void         lm_locate_cmd(int count, char *raw, t_syntax *synt)
{
    char                *tmp;

    tmp = ft_strchr(raw, '#');
    if ((!synt->s_cmd || !synt->e_cmd) && (tmp != NULL && raw[1] == '#'))
    {
        if (!synt->s_cmd)
        {
            if (ft_strcmp(tmp, "##start"))
            {
                synt->s_cmd = 1;
                synt->e_pos = count;
            }
        }
        if (!synt->e_cmd)
        {
            if (ft_strcmp(tmp, "##end"))
            {
                synt->e_cmd = 1;
                synt->s_pos = count;
            }
        }
    }
}

static int              lm_get_vertices(int count, char *raw, t_syntax *synt,
                        t_lmdata *data, t_holder *holder)
{
    int                 index;
    char                *tmp;
    char                *tmp2;
    int                 value;

    index = 0;
    value = 0;
    if (synt->s_cmd > 0 && (synt->e_pos == count - 1))
    {
        synt->s_vert = count;
        return (lm_add_vertex(data, raw, 'e', synt));
    }
    if (synt->e_cmd > 0 && (synt->s_pos == count - 1))
    {
        synt->e_vert = count;
        return (lm_add_vertex(data, raw, 's', synt));
    }
    if (count > 0 && (count != synt->s_vert && count != synt->e_vert)
            && (count != synt->s_pos && count != synt->e_pos))
    {
        tmp = ft_strchr(raw, '-');
        tmp2 = ft_strchr(raw, '#');
        if (tmp == NULL && tmp2 == NULL)
            return (lm_add_vertex(data, raw, 'v', synt));
        else if (tmp2 == NULL && tmp != NULL)
            return (lm_ext_conn(holder, data, raw));
    }
    return (1);
}

static void         lm_get_ant_num(int count, char *raw, t_lmdata *ldata, t_syntax *synt)
{
    int             index;
    int             value;

    index = 0;
    if (count == 0)
    {
        if (!ft_isdigit(raw[index + 1]))
        {
            value = raw[index] - '0';
            ldata->nbants = (value > 0) ? value : 0;
            synt->nb_state = 1;
        }
        if (ft_isdigit(raw[index + 1]))
        {
            ldata->nbants = (ft_atoi(raw) > 0) ? ft_atoi(raw) : 0;
            synt->nb_state = 1;
        }
    }
}

int                 lm_validate(t_syntax *synt, t_lmdata *lmdata)
{
    if (!synt->nb_state || !synt->s_cmd || !synt->e_cmd || synt->error)
        return (0);
    if (lmdata->nbants == 0 || lmdata->nb_nodes == 0)
        return (0);
    return (1);
}

void                lm_parser(int fd, t_syntax *synt, t_lmdata *ldata, 
                    t_holder *tmp_data)
{
    char            *raw;
    int             ret;
    int             index;

    index = 0;
    while ((ret = get_next_line(fd, &raw)))
    {
        if (ret == -1)
        {
            synt->error = 1;
            return ;
        }
        lm_get_ant_num(index, raw, ldata, synt);
        lm_locate_cmd(index, raw, synt);
        if (!lm_get_vertices(index, raw, synt, ldata, tmp_data))
        {
            synt->error = 1;
            return ;
        }
        index++;
    }
}